### Function

# GLib locale_from_utf8

#### Declaration [src]

    gchar*
    g_locale_from_utf8 (
      const gchar* utf8string,
      gssize len,
      gsize* bytes_read,
      gsize* bytes_written,
      GError** error
    )

#### Description [src]

Converts a string from UTF-8 to the encoding used for strings by the C runtime (usually the same as that used by the operating system) in the current locale. On Windows this means the system codepage.

The input string shall not contain nul characters even if the `len` argument is positive. A nul character found inside the string will result in error `G_CONVERT_ERROR_ILLEGAL_SEQUENCE`. Use `g_convert()` to convert input that may contain embedded nul characters.

#### Parameters

`utf8string`

  Type: `const gchar*`

  A UTF-8 encoded string.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`len`

  Type: `gssize`

  The length of the string, or -1 if the string is nul-terminated.

`bytes_read`

  Type: `gsize*`

  Location to store the number of bytes in the input string that were successfully converted, or `NULL`. Even if the conversion was successful, this may be less than `len` if there were partial characters at the end of the input. If the error `G_CONVERT_ERROR_ILLEGAL_SEQUENCE` occurs, the value stored will be the byte offset after the last valid input sequence.

  The argument will be set by the function.
  The argument can be `NULL`.

`bytes_written`

  Type: `gsize*`

  The number of bytes stored in the output buffer (not including the terminating nul).

  The argument will be set by the function.
  The argument can be `NULL`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `guint8`

         A newly-allocated buffer containing the converted string,
         or `NULL` on an error, and error will be set.

The length of the array is in the `bytes_written` argument.
The caller of the function takes ownership of the data, and is responsible for freeing it.